//Qualquer duvida entrar em contato com:
// Marcelo Braun -> mbraun@ez-poa.com.br
// Silton Sommer -> silton@pucrs.br
// Andre Antoniazzi -> andre@netsul.com.br

unit UExibe;

interface
uses classes, OpenGL, Udxf, UAux;

var
  XJ, YJ, ZJ,				// --- Nova posicao (X,Y,Z) dada pelo joystick
  metros,   				// --- Quanto deve-se deslocar o avatar
  AJ: real;					// --- Angulo que deve-se girar o avatar (dado pelo joystick)

  procedure ExibeFACE3D (L: TList; strip: boolean);
  procedure ExibeLINE (L: TList);
  procedure ExibeCIRCLE (L: TList);
  procedure ExibeARC (L: TList);
  procedure ExibePOLYLINE (L: TList);
  procedure ExibeINSERT(ObjSelecionado: integer);//Apont1,Dir1:TPonto3D);
  function RetornaBloco (NomeBloco: string):TBloco;
  function Verifica_Selecao(Apont1,Dir1: TPonto3D): integer;

implementation

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

function BitIsSet(Flag, bit: integer): boolean;
begin
	result:= false;
	if (flag>=128) then begin 	flag:=flag-128;
    if (bit=128) then result:= true;
  end;
	if (flag>=64) then begin 	flag:=flag-64;
    if (bit=64) then result:= true;
  end;
	if (flag>=32) then begin 	flag:=flag-32;
    if (bit=32) then result:= true;
  end;
	if (flag>=16) then begin 	flag:=flag-16;
    if (bit=16) then result:= true;
  end;
	if (flag>=8) then begin 	flag:=flag-8;
    if (bit=8) then result:= true;
  end;
	if (flag>=4) then begin 	flag:=flag-4;
    if (bit=4) then result:= true;
  end;
	if (flag>=2) then begin 	flag:=flag-2;
    if (bit=2) then result:= true;
  end;
	if (flag>=1) then begin 	flag:=flag-1;
    if (bit=1) then result:= true;
  end;
end;

		//***********************************************************//
		//***********************************************************//
		//   R O T I N A S  E X I B I D O R A S  D E  O P E N G L    //
		//***********************************************************//
		//***********************************************************//


//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:  L eh a lista que contem as faces a serem exibidas
//              strip nao eh mais utilizado
//              Exibe todas as faces da lista.
//***********************************************************//

procedure ExibeFACE3D (L: TList; strip: boolean);
var
	i,j: integer;
  F: TFace3D;
  pos,n: TPonto3D;
  m: tmatrix44;

begin
  N:= TPonto3D.Create;
  pos:= TPonto3D.Create;
  for i:=0 to L.Count-1 do
  begin
    F:= L.Items[i];
    // se tiver uma cor definida exibe com essa cor, senao exibe
    // com um tom de cinza.
    if F.Cor<>nil then
    begin
      if (F.Cor.R<>256) and (F.Cor.G<>256) and (F.Cor.B<>256) then
  	    glColor3f(F.Cor.R,F.Cor.G,F.Cor.B);
    end else
	    glColor3f(0.5,0.5,0.6);

    glBegin(GL_TRIANGLES);

    CalcNormal(TPonto3D(F.Vertices.Items[0]),
   	       TPonto3D(F.Vertices.Items[1]),
               TPonto3D(F.Vertices.Items[2]),n);
    glNormal3f(-N.X,-N.Y,-N.Z);

      //desenha a face utilizando-se dois triangulos
      //suponha uma face com os seguintes vertices:
      //        1   2
      //
      //        4   3
      //os triangulos seriam: 1 2 3 e 1 3 4
	  	for j:=0 to 2 do
	        begin
		   with TPonto3D(F.Vertices.Items[j])
                   do glVertex3f(x,y,z);
	        end;

	 		with (TPonto3D(F.Vertices.Items[0])) do
	  		glVertex3f(x,y,z);
	 		with (TPonto3D(F.Vertices.Items[2])) do
	  		glVertex3f(x,y,z);
	 		with (TPonto3D(F.Vertices.Items[3])) do
 	  		glVertex3f(x,y,z);
    glEnd;

  end;
  N.Free;
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

procedure ExibeLINE (L: TList);
var
	i: integer;
begin

  for i:=0 to L.Count-1 do
  begin
  	glBegin	(GL_LINES);
    	with TLinha(L.Items[i]) do
      begin
      	glColor4f(1,0,0,0.3);
      	glVertex3f(Inicio.x,Inicio.y,Inicio.z);
        glVertex3f(Fim.x,Fim.y,Fim.z);
      end;
    glEnd;
  end;

end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio: Essas rotinas (circle e arc) nao estao levando em consideracao
//  algumas das informacoes opcionais que podem ser definidas pelo arquivo DXF,
//  como extrusao, e rotacao sobre eixo vertical
//***********************************************************//

procedure ExibeCIRCLE (L: TList);
var
	i: integer;
  j: real;
begin
  glColor3f(1,0,0);
	for i:=0 to L.Count-1 do
  begin
  	j:=0;
   	glBegin(GL_TRIANGLE_FAN);
			while j<2*3.15 do
      begin
		  	with TCirculo(L.Items[i]) do
		    	glVertex3f(Centro.x + Raio*cos(j), Centro.y + Raio*sin(j), Centro.z);
  	    j:=j+3.14/7;
      end;
    glEnd;
  end;

end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio:                                               //
//***********************************************************//

procedure ExibeARC (L: TList);
var
	i: integer;
  j: real;
begin
  glColor3f(1,0,0);

	for i:=0 to L.Count-1 do
  begin
  	with TArco(L.Items[i]) do
    begin
	  	j:=AngIni*2.3/360;
      glBegin(GL_TRIANGLE_FAN);

				while j< AngFim*2.3/360 do
	      begin
 		    	glVertex3f(Centro.x + Raio*cos(j), Centro.y + Raio*sin(j), Centro.z);
	  	    j:=j+3.14/20;
	      end;

	    glEnd;
    end;
  end;
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio: Rotina em estado inicial, ainda muuiito primitiva para
//  exibir uma POLYLINE. Acabamos deixando essa rotina de lado, pois nao
//  iriamos usar. Todos os arquivos que tinhamos foram conseguidos atravez
//  da conversao de arquivos VRML para DXF, e os conversores por nos utili-
//  zados so usavam 3DFace. Polylines sao muito utilizadas por arquivos
//  gerados pelo AutoCAD.
//***********************************************************//

procedure ExibePOLYLINE (L: TList);
var
	PL: TPolyLine;
  F: TFace;
  i,j: integer;
begin

	for i:=0 to L.Count-1 do
  begin
  	PL:= L.Items[i];
    if (BitIsSet(PL.Flag,64)) then
    begin

      for j:=0 to PL.Faces.Count-1 do
      begin
	     	F:= PL.Faces.Items[j];
			glBegin(GL_TRIANGLE_STRIP);
				glVertex3f(TVertice(PL.Vertices.Items[Abs(TFace(PL.Faces.Items[j]).Fst-1)]).Coord.x,
        					 TVertice(PL.Vertices.Items[Abs(F.Fst-1)]).Coord.y,
                   TVertice(PL.Vertices.Items[Abs(F.Fst-1)]).Coord.z);

				glVertex3f(TVertice(PL.Vertices.Items[Abs(F.Snd-1)]).Coord.x,
        					 TVertice(PL.Vertices.Items[Abs(F.Snd-1)]).Coord.y,
                   TVertice(PL.Vertices.Items[Abs(F.Snd-1)]).Coord.z);

				glVertex3f(TVertice(PL.Vertices.Items[Abs(F.Trd-1)]).Coord.x,
        					 TVertice(PL.Vertices.Items[Abs(F.Trd-1)]).Coord.y,
                   TVertice(PL.Vertices.Items[Abs(F.Trd-1)]).Coord.z);
      glEnd;
      end;
    end;
  end;
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio: Retorna o bloco com nome igual a NOMEBLOCO. Esse bloco
//  se existir eh definido no arquivo DXF.
//***********************************************************//

function RetornaBloco (NomeBloco: string):TBloco;
var
	i: integer;
begin
	Result:= nil;
	for i:=0 to LBloco.Count-1 do
  begin

  	if (TBloco(LBloco.Items[i]).Nome = NomeBloco) then
    begin
    	Result:= TBloco(LBloco.Items[i]);
      exit;
    end;

  end;
end;

//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio: Exibe todos os INSERTS, e se algum objete estiver sendo
//  manipulado pelo usuario, esse objeto eh desenhado com a cor branca.
//***********************************************************//
procedure ExibeINSERT(ObjSelecionado: integer);//Apont1,Dir1:TPonto3D);
var
	i: integer;
  Bloco: TBloco;
  Insert: TInsert;
  F: TFace3D;
begin

    for i:=0 to LInsert.Count-1 do
    begin
       	Insert:= TInsert(LInsert.Items[i]);
        Bloco:= nil;
        //retorna o bloco correspondente a insercao atual
            Bloco:= RetornaBloco(Insert.NomeBloco);
        if Bloco=nil then break;
         glPushMatrix;
        //se nao deve ser inserido na origem do sistema de coordenadas local,
        //entao faz a translacao
    	with Insert.PtInsercao do
        begin
           if ((x<>0) or (y<>0) or (z<>0)) then
	   glTranslatef(x,y,z);
        end;

      with Insert do
      begin
        //aplica a rotacao definida no arquivo DXF
      	if (AngRotacao<>0) then
	      	glRotatef(AngRotacao,UpDir.x,UpDir.y,UpDir.z);
        //esses valores nao sao lidos do arquivo e no inicio sao igual a zero
        //esses valores sao alterados quando o usuario seleciona e rotaciona
        //o objeto
        if (Yaw<>0) then
          glRotatef(Yaw,0,1,0);
        if (Pitch<>0) then
          glRotatef(Pitch,1,0,0);
        if (Roll<>0) then
          glRotatef(Roll,0,0,1);
       	if ((EscalaX<>1) or (EscalaY<>1) or (EscalaZ<>1)) then
	        glScalef(EscalaX, EscalaY, EscalaZ);
      end;

      if Insert.Cor <> nil then
        glColor3f(Insert.Cor.R,Insert.Cor.G,Insert.Cor.B);
      //if i = objmproximo then glColor3f(1,1,1);
      // Manda exibir as entidades que compoem o objeto
	    ExibeFace3D(Bloco.BLFace3D, true);
	    ExibeLINE(Bloco.BLLinha);
	    ExibeARC(Bloco.BLArco);
	    ExibeCIRCLE(Bloco.BLCirculo);
//      ExibePOLYLINE(Bloco.BLPolyLine);
    glPopMatrix;
//    glEndList;

  end;
end;


//***********************************************************//
//	Data: __/__/____   Autor: ____________________           //
//	Descrio: rotina nem um pouco otimizada, e que ainda nao esta completa
//  ela funciona corretamente, mas so esta trabalhando com 3DFace, a entidade
//  mais utilizada nos arquivos que tinhamos.
//  Ela recebe como paramentros o ponto em que o rastreador esta e o ponto
//  para onde o mesmo esta apontado. E retorna o indice, dentro da lista de
//  insercoes (LInsert) do objeto cortado pela linha de apontamene que esteja
//  mais proximo do apontador.
//  Pra fazer isso precisavamos das coordenadas, em relacao a origem do sistema
//  de coordenadas, de todos os vertices de um objeto. Para entao calcularmos a
//  intersecao e verificar se este seria o objeto cortado pela linha de aponta-
//  mento mais proximo do apontador.
//  Como j haviamos apanhado bastante das funcoes seno e coseno para calcular
//  rotacoes, decidimos deixar o OpenGL calcular o que precisavamos.
//***********************************************************//

function Verifica_Selecao(Apont1,Dir1: TPonto3D): integer;
var
  Insert: TInsert;
  Bloco: TBloco;
  i,k,l: integer;
  PtIntersecao1,VetAux1,VetApont1,p1,p2,p3,p4,Normal: tponto3d;
  DistApontPlano, DistDirPlano: real;MenorDist: real;
  ObjMProximo: integer;
  F: TFace3D;
  M: TMatrix44;
  obj: gluquadricobj;
begin
  obj:=gluNewQuadric();
  result:= -1;
  VetApont1:= TPonto3D.Create;
  //Calcula o vetor de apontamento
  CalcVetor(Dir1,Apont1,VetApont1);
  PtIntersecao1:= TPonto3D.Create;
  VetAux1:= TPonto3D.Create;
  p1:= TPonto3d.create;
  p2:= TPonto3d.create;
  p3:= TPonto3d.create;
  p4:= TPonto3d.create;
  Normal:= TPonto3D.Create;

  //Inicializacao da variavel de controle da menor distancia de um objeto
  //ate o apontador
  MenorDist:=65535;
  ObjMProximo:=-1;
  //varre os objetos inseridos a procura do que eh interseptado pela linha.
   for i:=0 to LInsert.Count-1 do
   //for i:=0 to 0 do
   begin
  	Insert:= TInsert(LInsert.Items[i]);

        Bloco:= nil;
        Bloco:= RetornaBloco(Insert.NomeBloco);
        if Bloco=nil then break;

        glPushMatrix;
      //Aplica as transformacoes necessarias que a matriz do opengl seja alterada
      //e possamos entao perguntar as posicoes dos vertices que queremos.
    	with Insert.PtInsercao do
        begin
      	     if ((x<>0) or (y<>0) or (z<>0))
             then  glTranslatef(x,y,z);
        end;

      with Insert do
      begin
      	if (AngRotacao<>0) then
          glRotatef(AngRotacao,UpDir.x,UpDir.y,UpDir.z);
        if (Yaw<>0) then
          glRotatef(Yaw,0,1,0);
        if (Pitch<>0) then
          glRotatef(Pitch,1,0,0);
        if (Roll<>0) then
          glRotatef(Roll,0,0,1);
       	if ((EscalaX<>1) or (EscalaY<>1) or (EscalaZ<>1)) then
          glScalef(EscalaX, EscalaY, EscalaZ);
      end;

  ///////////////////////////////////////
  //Aqui deveriam ser calculadas as posicoes de todos os vertices que compoem o
  //objeto, mas nos soh implementamos a verificacao dos vertices das faces3D que
  //compoem o objeto.
  //
  //Varre todas as faces3d que compoem o objeto atual
  for k:=0 to Bloco.BLFace3D.Count-1 do
  begin
    F:= Bloco.BLFace3D.Items[k];
      //para cada vertice da face atual multiplica a posicao do vertice pela
      //matriz do opengl e obtem a posicao em relacao a origem.
    for l:=0 to 3 do  //para cada 1 dos 3 vertices da face atual
    begin
      with TPonto3D(F.Vertices.Items[l]) do
        begin
          glGetFloatv(GL_MODELVIEW_MATRIX,@M);
            case l of
              0: begin
                 AtribuiP3D1(x,y,z,P1);
                 MatrixMultiply(M,P1);
                 end;
              1: begin
                 AtribuiP3D1(x,y,z,P2);
                 MatrixMultiply(M,P2);
                 end;
              2: begin
                 AtribuiP3D1(x,y,z,P3);
                 MatrixMultiply(M,P3);
                 end;
              3: begin
                 AtribuiP3D1(x,y,z,P4);
                 MatrixMultiply(M,P4);
                 end;
            end;
        end;
    end;//end for
///*************88
      CalcNormal(p1,p2,p3,Normal);  //3 vertices da face atual
      //soh eh necessario calcular a intersecao se a reta nao for paralela ao
      //plano. Uma reta eh paralela a um plano se o produto escalar entre o
      //vetor normal do plano e o vetor que define a reta for igual a zero.
      if (Produto_Escalar(VetApont1,Normal)<>0) then
      begin
        //calcula a intesecao entre a linha de apontamento e o plano da face
        Intersecao(Apont1,Dir1,p1,p2,p3,PtIntersecao1);
        //se a intersecao pertencer a face entao verifica se esse ponto de intersecao
        //esta mais proximo do apontador que o ponto mais proximo ate o momento (menordist)
        //se estiver faz o objeto atual ser o OBJMPROXIMO.
        if PtinPolygon(PtIntersecao1,p1,p2,p3,p4) then
        begin
        //so pra teste da rotina, desenha uma esfera no ponto de intersecao.
        glpushmatrix;
          glloadidentity;
          glcolor3f(1,1,1);
          gltranslatef(ptintersecao1.x,ptintersecao1.y,ptintersecao1.z);
          gluSphere(obj,10,7,7);

//          glutsolidsphere(0.4,7,7);
        glpopmatrix;

          CalcVetor(PtIntersecao1,Apont1,VetAux1);
          DistApontPlano:=Modulo(VetAux1);

          CalcVetor(PtIntersecao1,Dir1,VetAux1);
          DistDirplano:=Modulo(VetAux1);

          //Na seguinte situacao a linha de apontamento atravessa 3 objetos,
          //e somento o obj2 deve ser selecionado. Usando somente verificacao
          //por distancia ja pode-se ignorar o OBJ3. Mas usando so verificacao
          //por distancia o OBJ1 seria selecionado. Deve-se entao fazer a seguinte
          //verificacao: se a distancia entre o ponto de intersecao e o objeto de
          //apontamento for maior que a distancia entre o ponto de intersao e o
          //ponto de direcao, entao o objeto pode-se ser selecionado caso ele
          //seja o mais proximo
          // obj1---apont--->dir-->obj2-->obj3

          if (DistApontPlano>DistDirPlano)
          then if (DistApontPlano<MenorDist)
               then begin
                      MenorDist:=DistApontPlano;
                      ObjMProximo:=i;

//              ObjPtInsOriginal:= Insert.PtInsercao;
              //no final da execucao essa variavel tera o indice do objeto
              //apontado que esta mais proximo do apontador.
                      result:=i;
                    end;

        end;
      end;
//????????////??????
  end; // fim do laco que verifica as faces3d
  // aqui deve-se fazer a verificacao dos demais vertices que compoem o objeto,
  // principalmente de polylines.
  glPopMatrix;
  end;
/////////////////////////////////////////
  PtIntersecao1.Free;
  VetAux1.Free;
  VetApont1.Free;
  p1.Free;
  p2.Free;
  p3.Free;
  p4.Free;
  Normal.Free;
  gluDeleteQuadric(obj);

end;



end.
